"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.KafkaAvroDeserializer = void 0;
const common_1 = require("@nestjs/common");
const confluent_schema_registry_1 = require("@kafkajs/confluent-schema-registry");
const loggers_1 = require("../loggers");
let KafkaAvroDeserializer = class KafkaAvroDeserializer {
    constructor(kafkaLogger) {
        this.kafkaLogger = kafkaLogger;
    }
    async initialize(configuration, randomSubject) {
        this.schemaRegistry = new confluent_schema_registry_1.SchemaRegistry(configuration.api, configuration === null || configuration === void 0 ? void 0 : configuration.options);
        if (!randomSubject) {
            return;
        }
        try {
            await this.schemaRegistry.getLatestSchemaId(randomSubject);
        }
        catch (reject) {
            this.kafkaLogger.error(`Error while testing schema registry connection (tested subject: ${randomSubject})`);
            throw reject;
        }
    }
    async deserialize(message) {
        var _a;
        try {
            const key = await this.schemaRegistry.decode(message.key);
            const event = (message === null || message === void 0 ? void 0 : message.value)
                ? await this.schemaRegistry.decode(message.value)
                : message === null || message === void 0 ? void 0 : message.value;
            return {
                arrival: (_a = new Date(Number(message.timestamp))) !== null && _a !== void 0 ? _a : new Date(),
                event,
                key,
            };
        }
        catch (reject) {
            this.kafkaLogger.error(`Error while deserializing message`, reject);
            throw reject;
        }
    }
};
KafkaAvroDeserializer = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [loggers_1.KafkaLogger])
], KafkaAvroDeserializer);
exports.KafkaAvroDeserializer = KafkaAvroDeserializer;
//# sourceMappingURL=kafka-avro.deserializer.js.map