export interface IKafkaEvent<V = Record<string, unknown>, K = Record<string, unknown>> {
    event: V;
    key: K;
    arrival: Date;
}
export declare type KafkaEventHandlerFunction = (event: IKafkaEvent) => Promise<void>;
export declare type KafkaEventEmitterFunction = () => Promise<void>;
export declare type EmitKafkaEventPayload<V, K> = {
    topic: string;
    event: IKafkaEvent<V, K>['event'];
    key: IKafkaEvent<V, K>['key'];
};
