import { MetadataScanner, ModulesContainer } from '@nestjs/core';
import { IKafkaEvent } from './interfaces';
import { KafkaLogger } from './loggers';
export declare class KafkaEventFunctionsService {
    private readonly modulesContainer;
    private readonly metadataScanner;
    private readonly kafkaLogger;
    private readonly eventHandlerMap;
    private eventEmitterTopics;
    constructor(modulesContainer: ModulesContainer, metadataScanner: MetadataScanner, kafkaLogger: KafkaLogger);
    explore(): void;
    getEventHandlerTopics(): string[];
    getEventEmitterTopics(): string[];
    callEventHandler(topic: string, event: IKafkaEvent): Promise<void>;
    private exploreMethodMetadata;
}
