"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var KafkaModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.KafkaModule = void 0;
const common_1 = require("@nestjs/common");
const kafka_service_1 = require("./kafka.service");
const providers_1 = require("./providers");
const kafka_event_functions_service_1 = require("./kafka-event-functions.service");
const core_1 = require("@nestjs/core");
const loggers_1 = require("./loggers");
const deserializer_1 = require("./deserializer");
const serializer_1 = require("./serializer");
let KafkaModule = KafkaModule_1 = class KafkaModule {
    constructor(kafkaEventFunctionsService) {
        this.kafkaEventFunctionsService = kafkaEventFunctionsService;
    }
    static registerAsync(options) {
        const svc = {
            provide: kafka_service_1.KafkaService,
            useClass: kafka_service_1.KafkaService,
            inject: [providers_1.KafkaModuleConfigurationProvider, kafka_event_functions_service_1.KafkaEventFunctionsService],
        };
        const kafkaModuleConfigurationProvider = this.createKafkaModuleConfigurationProvider(options);
        return {
            module: KafkaModule_1,
            global: true,
            imports: (options === null || options === void 0 ? void 0 : options.imports) || [],
            providers: [
                kafkaModuleConfigurationProvider,
                providers_1.KafkaModuleConfigurationProvider,
                deserializer_1.KafkaAvroDeserializer,
                serializer_1.KafkaAvroSerializer,
                loggers_1.KafkaLogger,
                svc,
            ],
            exports: [kafkaModuleConfigurationProvider, svc],
        };
    }
    static createKafkaModuleConfigurationProvider(options) {
        if (options.useFactory) {
            return {
                provide: providers_1.KAFKA_MODULE_CONFIGURATION,
                useFactory: options.useFactory,
                inject: options.inject || [],
            };
        }
        return {
            provide: providers_1.KAFKA_MODULE_CONFIGURATION,
            useFactory: async (optionsFactory) => await optionsFactory.creatKafkaModuleOptions(),
            inject: [options.useExisting || options.useClass],
        };
    }
    onModuleInit() {
        this.kafkaEventFunctionsService.explore();
    }
};
KafkaModule = KafkaModule_1 = __decorate([
    common_1.Global(),
    common_1.Module({
        providers: [kafka_event_functions_service_1.KafkaEventFunctionsService, core_1.MetadataScanner, loggers_1.KafkaLogger],
    }),
    __metadata("design:paramtypes", [kafka_event_functions_service_1.KafkaEventFunctionsService])
], KafkaModule);
exports.KafkaModule = KafkaModule;
//# sourceMappingURL=kafka.module.js.map