"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.KafkaLogger = void 0;
const common_1 = require("@nestjs/common");
const kafkajs_1 = require("kafkajs");
let KafkaLogger = class KafkaLogger extends common_1.ConsoleLogger {
    constructor() {
        super('Kafka');
    }
    getKafkaJSLoggingAdapter(logLevel) {
        return (logEntry) => {
            let method;
            switch (logLevel) {
                case kafkajs_1.logLevel.ERROR:
                case kafkajs_1.logLevel.NOTHING:
                    method = 'error';
                    break;
                case kafkajs_1.logLevel.WARN:
                    method = 'warn';
                    break;
                case kafkajs_1.logLevel.INFO:
                    method = 'log';
                    break;
                case kafkajs_1.logLevel.DEBUG:
                default:
                    method = 'debug';
                    break;
            }
            const { label, namespace } = logEntry;
            const _a = logEntry.log, { message } = _a, rest = __rest(_a, ["message"]);
            this[method](`${label} [${namespace}] ${message} ${JSON.stringify(rest)}`);
        };
    }
};
KafkaLogger = __decorate([
    common_1.Injectable({ scope: common_1.Scope.TRANSIENT }),
    __metadata("design:paramtypes", [])
], KafkaLogger);
exports.KafkaLogger = KafkaLogger;
//# sourceMappingURL=kafka.logger.js.map